#!/bin/bash

#			TODAY - FROM 8AM TO 8PM
#			MORNING - FROM 8AM TO 1PM
#			EVENING - FORM 1PM TO 5PM
#			WEEK - LAST 7DAYS

CMD_ARRAY=("$@")

# OLD SCRIPT 
#PLOT_SCRIPT="/opt/dailyjob/scripts/modify_plot.sh";

## NEW SCRIPT WIYTH TRANSPARENT SETUP
PLOT_SCRIPT="/opt/dailyjob/scripts/modify_plot_2.sh";


PLOT_PATH="/opt/dailyjob/performanceplot";
SEND_MAIL_PY="/opt/dailyjob/mailing_py/sendmail_with_attachments_2.py";

PLOT_NAME="$(date +%d_%b_%Y)"

## ALL TYPE OF PERFORMANCE PLOT 
RIGHT_NOW="$(date +%Y%m%d%H%M%S)";
TODAY="$(date +%Y%m%d)000000"
MORNING_8AM="$(date +%Y%m%d)080000"
EVENING_1PM="$(date +%Y%m%d)130000";
PAST_1_DAY="$(date --date='1 day ago' +%Y%m%d%H%M%S)";
PAST_2_DAY="$(date --date='2 day ago' +%Y%m%d%H%M%S)";
PAST_3_DAY="$(date --date='3 day ago' +%Y%m%d%H%M%S)";
PAST_WEEK="$(date --date='7 day ago' +%Y%m%d%H%M%S)";

MAIN(){
	
	echo "Input Arguments are: "
	echo "${CMD_ARRAY[@]}"
	
	## Empty the Performance Plot Dir
	rm -rfv ${PLOT_PATH}/*
	
	for ONE_ARG in ${CMD_ARRAY[@]};
	do
		
		echo "ONE_ARG Value is : ${ONE_ARG}" 
		
		if [[ $ONE_ARG == "today" ]]; then
			
			echo "Creating Plot for ${ONE_ARG}" 
			${PLOT_SCRIPT} ${MORNING_8AM} ${RIGHT_NOW} ${PLOT_PATH}/${PLOT_NAME}_TODAY.png
			
		elif [[ $ONE_ARG == "morning" ]]; then
					
			echo "Creating Plot for ${ONE_ARG}" 
			${PLOT_SCRIPT} ${MORNING_8AM} ${RIGHT_NOW} ${PLOT_PATH}/${PLOT_NAME}_MORNING.png
		
		elif [[ $ONE_ARG == "evening" ]]; then
			
			echo "Creating Plot for ${ONE_ARG}" 
			${PLOT_SCRIPT} ${EVENING_1PM} ${RIGHT_NOW} ${PLOT_PATH}/${PLOT_NAME}_EVENING.png
		
		elif [[ $ONE_ARG == "pastweek" ]]; then
			
			echo "Creating Plot for ${ONE_ARG}" 
			${PLOT_SCRIPT} ${PAST_WEEK} ${RIGHT_NOW} ${PLOT_PATH}/${PLOT_NAME}_PAST_WEEK.png
		
		elif [[ $ONE_ARG == "past1day" ]]; then
			
			echo "Creating Plot for ${ONE_ARG}" 
			${PLOT_SCRIPT} ${PAST_1_DAY} ${RIGHT_NOW} ${PLOT_PATH}/${PLOT_NAME}_PAST_1_DAY.png
		
		elif [[ $ONE_ARG == "all" ]]; then
			
			echo "Creating Plot for ${ONE_ARG}" 
			${PLOT_SCRIPT} ${TODAY} ${RIGHT_NOW} ${PLOT_PATH}/${PLOT_NAME}_TODAY.png
			${PLOT_SCRIPT} ${MORNING_8AM} ${RIGHT_NOW} ${PLOT_PATH}/${PLOT_NAME}_MORNING.png
			${PLOT_SCRIPT} ${EVENING_1PM} ${RIGHT_NOW} ${PLOT_PATH}/${PLOT_NAME}_EVENING.png
			${PLOT_SCRIPT} ${PAST_1_DAY} ${RIGHT_NOW} ${PLOT_PATH}/${PLOT_NAME}_PAST_1_DAY.png
			${PLOT_SCRIPT} ${PAST_WEEK} ${RIGHT_NOW} ${PLOT_PATH}/${PLOT_NAME}_PAST_WEEK.png
		
		else 
		
			echo "[+] Plot for ${ONE_ARG} will not be created {+}" 
			echo "[+] Wrong Arguments [+]"
			
		fi
		
	done
	
	## Send Mail Using Python Mailer Script
	VAL=${CMD_ARRAY[@]}
	echo $VAL
	/usr/bin/python ${SEND_MAIL_PY} $(echo "$VAL")
}

## BEGIN THE SCRIPT
MAIN

