from email.MIMEMultipart import MIMEMultipart
from email.MIMEText import MIMEText
from email.MIMEImage import MIMEImage
from email.MIMEBase import MIMEBase
from email import Encoders
import smtplib
import os
import ConfigParser
import subprocess

import traceback
import datetime
import sys

class CustomMailer:
	
	''' Config File Path '''
	configFile = '/opt/dailyjob/mailing_py/mailConfigFile.ini';

	''' For Time Being we are using File => authorized_key . It will fetch the First Key '''
	keyFile = "/root/.ssh/authorized_keys"

	''' Log File With Path: To Store AnyKind of Error or Crash logs '''
	sendMailerErrorLog = "/opt/dailyjob/sendMailer.log"
	
	''' Get the user Provided Message and Store it in userMessage '''
	def __init__(self, userMessage):
		self.userMessage = userMessage

	''' Get all the Config Data and Store it in Instance Variables '''
	def getConfigData(self):
		
		configData = ConfigParser.ConfigParser()
		configData.read(self.configFile);

		self.mailServer = configData.get("Mail_Details", "mailServer");
		self.senderID = configData.get("Mail_Details", "senderID");
		self.senderPasswd = configData.get("Mail_Details", "senderPasswd");
		self.subject = configData.get("Mail_Details", "subject");
		self.sendTo = configData.get("Mail_Details", "sendTo");
		self.sendCC = configData.get("Mail_Details", "sendCC");
		self.sendBCC = configData.get("Mail_Details", "sendBCC");
		self.folderName = configData.get("Attachments", "folderName");
		self.logFile = configData.get("Logs", "logFile");
		
	''' Create Mail Full Message Body '''
	def createMessage(self, displayMessage):
		
		''' Creating the Mail Content '''
		messageData = MIMEMultipart();

		''' Mail Header & Body '''
		messageData['Subject'] = self.subject;
		messageData['From'] = self.senderID;
		messageData['To'] = self.sendTo;
		
		if self.sendCC != "":
			print('[+] INSIDE IF != "" ->  sendCC Value: [+]', repr(self.sendCC))
			messageData['Cc'] = self.sendCC;
		
		print('[+] sendCC Value: [+]', repr(self.sendCC))
		
		if self.sendBCC != "":
			print('[+] INSIDE IF != "" ->  sendBCC Value: [+]', repr(self.sendBCC))
			messageData['Bcc'] = self.sendBCC;
			
		print('[+] sendBCC Value: [+]', repr(self.sendBCC))
		
		''' Transform the User Message in HTML Form '''
		displayMessage = '<h3> Performance Plot of Server (10.0.0.8) Which Includes <br> Reports for: %s </h3>' % (" & ".join(displayMessage))
		
		messageData.attach(MIMEText(displayMessage,'html'));

		''' File Attachments '''
		for file in os.listdir(self.folderName):
		
			fileWithPath = os.path.join(self.folderName, file);
			fileAttachment = open(fileWithPath, 'rb').read();
			sendFileData = MIMEBase('application', 'octet-stream');
			sendFileData.set_payload(fileAttachment);
			Encoders.encode_base64(sendFileData);
			sendFileData.add_header('Content-Disposition', 'attachment', filename=os.path.basename(fileWithPath))
			messageData.attach(sendFileData);
	
		return messageData
	
	'''  '''
	def getDecodedPasswd(self):
		
		''' [+]Security Update : Wncrypted Password '''
		passPhrase = open(self.keyFile,'r').readline().strip().split()[1];
		
		'''print('PassPhrase Data : %s' % (passPhrase))'''
		
		decPassword = subprocess.check_output("echo %s | openssl aes-256-cbc -d -a -pass pass:%s" % (self.senderPasswd, passPhrase), shell=True).strip();
		
		'''print('Decrypted Passwd : %s' % decPassword)'''
		
		return decPassword
	
	''' '''
	def mailSender(self, messageData):
		
		''' MAIL SENDING RELATED '''
		server = None
		try:
			server = smtplib.SMTP(self.mailServer, 587);
			server.starttls();
			#decPassword = self.getDecodedPasswd();
			decPassword = self.senderPasswd;
			server.login(self.senderID, decPassword);

			'''
				Key thing is to add the Recipients as a list of email IDs in the Sendmail call.
				Send All your Data in String Format to Convert that use FUNCTION : as_string() of Class MIMEMultipart
			'''

			''' Create Send List '''
			sendList = self.sendTo.split(',')
			
			if self.sendCC != "":
				for oneVal in self.sendCC.split(','):
					sendList.append(oneVal)
			if self.sendBCC != "":
				for oneVal in self.sendBCC.split(','):
					sendList.append(oneVal)
			
			print(sendList);

			server.sendmail(self.senderID, sendList, messageData.as_string());
			
		except Exception, e:
			exceptionTraceString = str(e)
			traceback.print_exc(file=sys.stdout)
			exceptionTime = datetime.date.today().ctime()

			print(exceptionTraceString)
			print(type(''.join(exceptionTraceString)))
			
			''' Log the Exception '''
			logFile = open(self.sendMailerErrorLog,'a+')
			logFile.write('\n-START-\n')
			traceback.print_exc(file=logFile)
			logFile.write('\n-END-\n')
			logFile.close()
			print('[+] Exception Trace Back Stored in File : sendMailer.log [+]')

		finally:
			print('[+] I am Finally Closing the SMTP Connection [+]')
			#server.quit();

	''' '''
	def doProcess(self):
		self.getConfigData()
		msgData = self.createMessage(self.userMessage)
		self.mailSender(msgData)
		

if __name__ == "__main__": 
    
	print('[+] Starting Sending mail To Recipients [+]')
	
	try:
		displayMessage = sys.argv[1:]
		print(displayMessage)
	except:
		raise Exception('[+] Please Provide Appropriate Arguments [+]')
		
	myMailer = CustomMailer(displayMessage);
	myMailer.doProcess()
	
